package com.zm.order.tool.server.response;

import com.alibaba.fastjson.JSON;
import com.aliyun.openservices.shade.org.apache.commons.lang3.builder.DiffBuilder;
import com.aliyun.openservices.shade.org.apache.commons.lang3.builder.DiffResult;
import com.aliyun.openservices.shade.org.apache.commons.lang3.builder.Diffable;
import com.aliyun.openservices.shade.org.apache.commons.lang3.builder.ToStringStyle;
import com.fastobject.diff.DiffLog;
import com.zm.order.tool.server.model.OrderAddr;
import com.zm.order.tool.server.model.OrderDiscount;
import com.zm.order.tool.server.model.OrderItem;
import com.zm.order.tool.server.model.OrderPayDetails;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * @Description 订单VO
 * @Author: ph
 * @Date: 2019/12/4 10:40
 */
public class OrderNewVO implements Serializable, Diffable<OrderNewVO> {

    /**
     * 主键
     */
    private Long id;

    /**
     * 业务类型
     */
    @ApiModelProperty("业务类型")
    private Integer bizType;

    @ApiModelProperty("订单号")
    private String orderNo;

    /**
     * 订单类型
     */
    private Integer orderType;

    /**
     * 订单子类型
     */
    private Integer orderSubType;

    /**
     * 商家id
     */
    private Long sellerId;

    /**
     * 门店id
     */
    private Long storeId;

    /**
     * 店内单号
     */
    private String storeOrderNo;

    /**
     * 用户id
     */
    private Long userId;

    /**
     * 联系方式
     */
    private String mobile;

    /**
     * 地址id
     */
    private Integer addrId;

    /**
     * 订单来源
     */
    private Integer source;

    /**
     * 来源单号
     */
    private String sourceNo;

    /**
     * 来源系统
     */
    private Integer fromSystem;

    /**
     * 订单总金额
     */
    private Integer totalAmount;

    /**
     * 打包总金额
     */
    private Integer packAmount;

    /**
     * 商品总金额
     */
    private Integer itemAmount;

    /**
     * 运费总金额
     */
    private Integer freightAmount;

    /**
     * 优惠总金额
     */
    private Integer discountAmount;

    /**
     * 实付金额
     */
    private Integer actualAmount;

    /**
     * 支付金额
     */
    private Integer payAmount;

    /**
     * 找零金额
     */
    private Integer changeAmount;

    /**
     * 是否独立收款
     */
    private Integer isAlone;

    /**
     * 支付方式
     */
    private Integer payType;

    /**
     * 开票状态
     */
    private Integer invoiceStatus;

    /**
     * 支付模式
     */
    private Integer payModel;

    /**
     * 付款人
     */
    private Long payer;

    /**
     * 支付单号
     */
    private String payNo;

    /**
     * 第三方支付单号
     */
    private String thirdPayNo;

    /**
     * 支付信息
     */
    private String payInfo;

    /**
     * 发票类型
     */
    private Integer invoiceType;

    /**
     * 履约类型
     */
    private Integer performanceType;

    /**
     * 履约平台
     */
    private String performancePlatform;

    /**
     * 是否立即履约
     */
    private Integer isImmediatePerformance;

    /**
     * 履约信息
     */
    private String performanceInfo;

    /**
     * 商品信息
     */
    private String itemInfo;

    /**
     * 折扣信息
     */
    private String discountInfo;

    /**
     * 商家备注
     */
    private String sellerRemarks;

    /**
     * 买家备注
     */
    private String buyerRemarks;

    /**
     * 是否打印
     */
    private Integer isReceipt;

    /**
     * 打印终端
     */
    private String receiptTerminal;

    /**
     * 状态
     */
    private Integer status;

    /**
     * 订单子状态
     */
    private Integer subStatus;

    /**
     * 支付状态
     */
    private Integer payStatus;

    /**
     * 售后状态
     */
    private Integer afterSaleStatus;

    /**
     * 履约状态
     */
    private Integer performanceStatus;

    /**
     * 评价状态
     */
    private Integer commentStatus;

    /**
     * 接单状态
     */
    private Integer receiveStatus;

    /**
     * 拒单原因
     */
    private String refusalReason;

    /**
     * 下单时间
     */
    private Date orderAt;

    /**
     * 支付时间
     */
    private Date payAt;

    /**
     * 评价时间
     */
    private Date commentAt;

    /**
     * 完成时间
     */
    private Date completedAt;

    /**
     * 接单时间
     */
    private Date receiveAt;

    /**
     * 扩展信息
     */
    private String features;

    /**
     * 创建时间
     */
    private Date createdAt;

    /**
     * 修改时间
     */
    private Date updatedAt;

    /**
     * 删除标识
     */
    private Integer isDeleted;

    /**
     * 业务子类型
     */
    private Integer bizSubType;

    /**
     * 支付标记
     */
    private Integer payFlag;

    /**
     * 支付明细
     */
    private String payDetailInfo;

    /**
     * 地址信息
     */
    private String addrInfo;

    /**
     * 存在退款单标记
     * 0：不存在 1：存在
     */
    private Integer refundFlag;

    @ApiModelProperty("商品列表")
    @DiffLog(name = "商品列表")
    private List<OrderItem> itemList;

    @ApiModelProperty("折扣列表")
    private List<OrderDiscount> discountList;

    @ApiModelProperty("支付详情列表")
    private List<OrderPayDetails> payDetailsList;

    @ApiModelProperty("订单地址")
    private OrderAddr orderAddr;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Integer getBizType() {
        return bizType;
    }

    public void setBizType(Integer bizType) {
        this.bizType = bizType;
    }

    public String getOrderNo() {
        return orderNo;
    }

    public void setOrderNo(String orderNo) {
        this.orderNo = orderNo;
    }

    public Integer getOrderType() {
        return orderType;
    }

    public void setOrderType(Integer orderType) {
        this.orderType = orderType;
    }

    public Integer getOrderSubType() {
        return orderSubType;
    }

    public void setOrderSubType(Integer orderSubType) {
        this.orderSubType = orderSubType;
    }

    public Long getSellerId() {
        return sellerId;
    }

    public void setSellerId(Long sellerId) {
        this.sellerId = sellerId;
    }

    public Long getStoreId() {
        return storeId;
    }

    public void setStoreId(Long storeId) {
        this.storeId = storeId;
    }

    public String getStoreOrderNo() {
        return storeOrderNo;
    }

    public void setStoreOrderNo(String storeOrderNo) {
        this.storeOrderNo = storeOrderNo;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public Integer getAddrId() {
        return addrId;
    }

    public void setAddrId(Integer addrId) {
        this.addrId = addrId;
    }

    public Integer getSource() {
        return source;
    }

    public void setSource(Integer source) {
        this.source = source;
    }

    public String getSourceNo() {
        return sourceNo;
    }

    public void setSourceNo(String sourceNo) {
        this.sourceNo = sourceNo;
    }

    public Integer getFromSystem() {
        return fromSystem;
    }

    public void setFromSystem(Integer fromSystem) {
        this.fromSystem = fromSystem;
    }

    public Integer getTotalAmount() {
        return totalAmount;
    }

    public void setTotalAmount(Integer totalAmount) {
        this.totalAmount = totalAmount;
    }

    public Integer getPackAmount() {
        return packAmount;
    }

    public void setPackAmount(Integer packAmount) {
        this.packAmount = packAmount;
    }

    public Integer getItemAmount() {
        return itemAmount;
    }

    public void setItemAmount(Integer itemAmount) {
        this.itemAmount = itemAmount;
    }

    public Integer getFreightAmount() {
        return freightAmount;
    }

    public void setFreightAmount(Integer freightAmount) {
        this.freightAmount = freightAmount;
    }

    public Integer getDiscountAmount() {
        return discountAmount;
    }

    public void setDiscountAmount(Integer discountAmount) {
        this.discountAmount = discountAmount;
    }

    public Integer getActualAmount() {
        return actualAmount;
    }

    public void setActualAmount(Integer actualAmount) {
        this.actualAmount = actualAmount;
    }

    public Integer getPayAmount() {
        return payAmount;
    }

    public void setPayAmount(Integer payAmount) {
        this.payAmount = payAmount;
    }

    public Integer getChangeAmount() {
        return changeAmount;
    }

    public void setChangeAmount(Integer changeAmount) {
        this.changeAmount = changeAmount;
    }

    public Integer getIsAlone() {
        return isAlone;
    }

    public void setIsAlone(Integer isAlone) {
        this.isAlone = isAlone;
    }

    public Integer getPayType() {
        return payType;
    }

    public void setPayType(Integer payType) {
        this.payType = payType;
    }

    public Integer getInvoiceStatus() {
        return invoiceStatus;
    }

    public void setInvoiceStatus(Integer invoiceStatus) {
        this.invoiceStatus = invoiceStatus;
    }

    public Integer getPayModel() {
        return payModel;
    }

    public void setPayModel(Integer payModel) {
        this.payModel = payModel;
    }

    public Long getPayer() {
        return payer;
    }

    public void setPayer(Long payer) {
        this.payer = payer;
    }

    public String getPayNo() {
        return payNo;
    }

    public void setPayNo(String payNo) {
        this.payNo = payNo;
    }

    public String getThirdPayNo() {
        return thirdPayNo;
    }

    public void setThirdPayNo(String thirdPayNo) {
        this.thirdPayNo = thirdPayNo;
    }

    public String getPayInfo() {
        return payInfo;
    }

    public void setPayInfo(String payInfo) {
        this.payInfo = payInfo;
    }

    public Integer getInvoiceType() {
        return invoiceType;
    }

    public void setInvoiceType(Integer invoiceType) {
        this.invoiceType = invoiceType;
    }

    public Integer getPerformanceType() {
        return performanceType;
    }

    public void setPerformanceType(Integer performanceType) {
        this.performanceType = performanceType;
    }

    public String getPerformancePlatform() {
        return performancePlatform;
    }

    public void setPerformancePlatform(String performancePlatform) {
        this.performancePlatform = performancePlatform;
    }

    public Integer getIsImmediatePerformance() {
        return isImmediatePerformance;
    }

    public void setIsImmediatePerformance(Integer isImmediatePerformance) {
        this.isImmediatePerformance = isImmediatePerformance;
    }

    public String getPerformanceInfo() {
        return performanceInfo;
    }

    public void setPerformanceInfo(String performanceInfo) {
        this.performanceInfo = performanceInfo;
    }

    public String getItemInfo() {
        return itemInfo;
    }

    public void setItemInfo(String itemInfo) {
        this.itemInfo = itemInfo;
    }

    public String getDiscountInfo() {
        return discountInfo;
    }

    public void setDiscountInfo(String discountInfo) {
        this.discountInfo = discountInfo;
    }

    public String getSellerRemarks() {
        return sellerRemarks;
    }

    public void setSellerRemarks(String sellerRemarks) {
        this.sellerRemarks = sellerRemarks;
    }

    public String getBuyerRemarks() {
        return buyerRemarks;
    }

    public void setBuyerRemarks(String buyerRemarks) {
        this.buyerRemarks = buyerRemarks;
    }

    public Integer getIsReceipt() {
        return isReceipt;
    }

    public void setIsReceipt(Integer isReceipt) {
        this.isReceipt = isReceipt;
    }

    public String getReceiptTerminal() {
        return receiptTerminal;
    }

    public void setReceiptTerminal(String receiptTerminal) {
        this.receiptTerminal = receiptTerminal;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Integer getSubStatus() {
        return subStatus;
    }

    public void setSubStatus(Integer subStatus) {
        this.subStatus = subStatus;
    }

    public Integer getPayStatus() {
        return payStatus;
    }

    public void setPayStatus(Integer payStatus) {
        this.payStatus = payStatus;
    }

    public Integer getAfterSaleStatus() {
        return afterSaleStatus;
    }

    public void setAfterSaleStatus(Integer afterSaleStatus) {
        this.afterSaleStatus = afterSaleStatus;
    }

    public Integer getPerformanceStatus() {
        return performanceStatus;
    }

    public void setPerformanceStatus(Integer performanceStatus) {
        this.performanceStatus = performanceStatus;
    }

    public Integer getCommentStatus() {
        return commentStatus;
    }

    public void setCommentStatus(Integer commentStatus) {
        this.commentStatus = commentStatus;
    }

    public Integer getReceiveStatus() {
        return receiveStatus;
    }

    public void setReceiveStatus(Integer receiveStatus) {
        this.receiveStatus = receiveStatus;
    }

    public String getRefusalReason() {
        return refusalReason;
    }

    public void setRefusalReason(String refusalReason) {
        this.refusalReason = refusalReason;
    }

    public Date getOrderAt() {
        return orderAt;
    }

    public void setOrderAt(Date orderAt) {
        this.orderAt = orderAt;
    }

    public Date getPayAt() {
        return payAt;
    }

    public void setPayAt(Date payAt) {
        this.payAt = payAt;
    }

    public Date getCommentAt() {
        return commentAt;
    }

    public void setCommentAt(Date commentAt) {
        this.commentAt = commentAt;
    }

    public Date getCompletedAt() {
        return completedAt;
    }

    public void setCompletedAt(Date completedAt) {
        this.completedAt = completedAt;
    }

    public Date getReceiveAt() {
        return receiveAt;
    }

    public void setReceiveAt(Date receiveAt) {
        this.receiveAt = receiveAt;
    }

    public String getFeatures() {
        return features;
    }

    public void setFeatures(String features) {
        this.features = features;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Integer getIsDeleted() {
        return isDeleted;
    }

    public void setIsDeleted(Integer isDeleted) {
        this.isDeleted = isDeleted;
    }

    public Integer getBizSubType() {
        return bizSubType;
    }

    public void setBizSubType(Integer bizSubType) {
        this.bizSubType = bizSubType;
    }

    public Integer getPayFlag() {
        return payFlag;
    }

    public void setPayFlag(Integer payFlag) {
        this.payFlag = payFlag;
    }

    public String getPayDetailInfo() {
        return payDetailInfo;
    }

    public void setPayDetailInfo(String payDetailInfo) {
        this.payDetailInfo = payDetailInfo;
    }

    public String getAddrInfo() {
        return addrInfo;
    }

    public void setAddrInfo(String addrInfo) {
        this.addrInfo = addrInfo;
    }

    public Integer getRefundFlag() {
        return refundFlag;
    }

    public void setRefundFlag(Integer refundFlag) {
        this.refundFlag = refundFlag;
    }

    public List<OrderItem> getItemList() {
        return itemList;
    }

    public void setItemList(List<OrderItem> itemList) {
        this.itemList = itemList;
    }

    public List<OrderDiscount> getDiscountList() {
        return discountList;
    }

    public void setDiscountList(List<OrderDiscount> discountList) {
        this.discountList = discountList;
    }

    public List<OrderPayDetails> getPayDetailsList() {
        return payDetailsList;
    }

    public void setPayDetailsList(List<OrderPayDetails> payDetailsList) {
        this.payDetailsList = payDetailsList;
    }

    public OrderAddr getOrderAddr() {
        return orderAddr;
    }

    public void setOrderAddr(OrderAddr orderAddr) {
        this.orderAddr = orderAddr;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

    @Override
    public DiffResult diff(OrderNewVO obj) {
        // No need for null check, as NullPointerException correct if obj is null
        return new DiffBuilder(this, obj, ToStringStyle.JSON_STYLE)
//                .append("bizType", this.bizType, obj.bizType)
                .append("orderType", this.orderType, obj.orderType)
                .append("orderSubType", this.orderSubType, obj.orderSubType)
                .append("storeId", this.storeId, obj.storeId)
                .append("storeOrderNo", this.storeOrderNo, obj.storeOrderNo)
                .append("mobile", this.mobile, obj.mobile)
                .append("source", this.source, obj.source)
                .append("sourceNo", this.sourceNo, obj.sourceNo)
                .append("fromSystem", this.fromSystem, obj.fromSystem)
                .append("totalAmount", this.totalAmount, obj.totalAmount)
                .append("packAmount", this.packAmount, obj.packAmount)
                .append("itemAmount", this.itemAmount, obj.itemAmount)
                .append("freightAmount", this.freightAmount, obj.freightAmount)
                .append("discountAmount", this.discountAmount, obj.discountAmount)
                .append("actualAmount", this.actualAmount, obj.actualAmount)
                .append("payAmount", this.payAmount, obj.payAmount)
                .append("changeAmount", this.changeAmount, obj.changeAmount)
                .append("payType", this.payType, obj.payType)
                .append("payModel", this.payModel, obj.payModel)
                .append("payer", this.payer, obj.payer)
                .append("payNo", this.payNo, obj.payNo)
                .append("thirdPayNo", this.thirdPayNo, obj.thirdPayNo)
                .append("payInfo", this.payInfo, obj.payInfo)
                .append("isAlone", this.isAlone, obj.isAlone)
                .append("payStatus", this.payStatus, obj.payStatus)
                .append("invoiceType", this.invoiceType, obj.invoiceType)
                .append("performanceType", this.performanceType, obj.performanceType)
                .append("isImmediatePerformance", this.isImmediatePerformance, obj.isImmediatePerformance)
                .append("performancePlatform", this.performancePlatform, obj.performancePlatform)
                .append("performanceInfo", this.performanceInfo, obj.performanceInfo)
                .append("sellerRemarks", this.sellerRemarks, obj.sellerRemarks)
                .append("buyerRemarks", this.buyerRemarks, obj.buyerRemarks)
                .append("isReceipt", this.isReceipt, obj.isReceipt)
                .append("receiptTerminal", this.receiptTerminal, obj.receiptTerminal)
                .append("status", this.status, obj.status)
                .append("afterSaleStatus", this.afterSaleStatus, obj.afterSaleStatus)
                .append("receiveStatus", this.receiveStatus, obj.receiveStatus)
                .append("performanceStatus", this.performanceStatus, obj.performanceStatus)
                .append("commentStatus", this.commentStatus, obj.commentStatus)
                .append("refusalReason", this.refusalReason, obj.refusalReason)
                .append("orderAt", this.orderAt, obj.orderAt)
                .append("payAt", this.payAt, obj.payAt)
                .append("commentAt", this.commentAt, obj.commentAt)
                .append("completedAt", this.completedAt, obj.completedAt)
                .append("receiveAt", this.receiveAt, obj.receiveAt)
                .append("features", this.features, obj.features)
                .append("isDeleted", this.isDeleted, obj.isDeleted)
                .append("bizSubType", this.bizSubType, obj.bizSubType)
                .append("invoiceStatus", this.invoiceStatus, obj.invoiceStatus)
                .append("subStatus", this.subStatus, obj.subStatus)
                .build();
    }

}
